#ifndef __PT_SCOPES_H
#define __PT_SCOPES_H

#include <stdint.h>
#include <stdbool.h>

typedef struct scopeChannel_t
{
	const int8_t *newData, *data;
	volatile bool active, retriggered, didSwapData, emptyScopeDrawn;
	bool loopFlag, newLoopFlag;
	int8_t volume;
	int32_t length, newLength, pos, loopStart, newLoopStart;
	uint32_t posFrac;
} scopeChannel_t;

int32_t getSampleReadPos(uint8_t ch, uint8_t smpNum);
void updateScopes(void);
void drawScopes(void);
bool initScopes(void);
void waitOnScopes(void);
void clearScopes(void);

extern scopeChannel_t scope[4];

#endif
